use strict;
use warnings;
#use List::Util qw(sample);
use File::Slurp;
use utf8;
use HTML::Entities qw (decode_entities encode_entities_numeric);
use Text::Unaccent::PurePerl qw(unac_string);
use URI::Escape;
#binmode(STDIN, ":utf8");
#binmode(STDOUT, ":utf8");
use Data::Dumper;

my ($infile, $addfile, $outfile) = @ARGV;
$infile ||= './scrap8.html';
$addfile ||= './cf.txt';
$outfile ||= './out.html';
my @list = read_file($infile);
my @more = read_file($addfile);
#my @more = read_file($outfile);
#my @more = read_file('./one.txt');
#my @targetmore = @more;

my ($listref, $listorderedref) = getplaces(@list);
#my @listordered;
#$Data::Dumper::Useqq = 1;
#print Dumper $listref;
putplaces(\@more, $listref, $listorderedref);
write_file($outfile, header(), @{$listorderedref}, footer());

sub getplaces {
	my @list = @_;
	my $list = {};
	my @listordered;
	
	for (@list) {
		chomp;
#		if ($_ !~ /^</ && $_ =~ /<br>$/) {
#		if ($_ =~ /^<!/ || $_ =~ /<br>$/) {		
		if (/^<!/ || /<br>$/) {
			my $string = $_;
#			$list->{lc $_} = undef;
			decode_entities($string);
			my $decoded = $string;
#			my $txt = unac_string(lc(decode_entities($_)));
#			utf8::encode($string);
			my $txt = unac_string("UTF-8",lc($string));
#			my $txt = unac_string(lc($string));			
#			my $remac = remove_accents($string);
			my $blot = mixedregex($_);
#			my $remac = remove_accents($blot);
#			my $blot =~ s[\\0([0-7]{3})][chr oct $1]egr;								
#			print "read in $remac", unac_string("UTF-8",$blot), "\n";
			$blot = unac_string("UTF-8", $blot);
			if (exists $list->{$txt}) {
				print "$txt duplicate\n";
				push @listordered, "<!-- $_ -->\n";				
			} else {
#				print "$txt entered\n";
#				print "$_ entered\n";
#				print "$decoded entered\n";
#				$list->{$remac} = 0;#undef;	
				$list->{$blot} = 0;#undef;								
				$list->{$txt} = 1;#undef;
				$list->{$_} = 2;#undef;
				$list->{$decoded} = 3;#undef;				
				push @listordered, "$_\n";
			}
#			push @listordered, "$_\n";
		}
	}
	
	return $list, \@listordered;
}
#for (keys %list) {
#	print "scrap $_\n";
#}
=start
my $count = 0;

for (@list) {
	print "$count $_\n";
	$count++;
}
=cut

sub putplaces {
	my ($moreref, $listref, $listorderedref) = @_;
	
	for (@{$moreref}) {
		chomp;
		s/^\s+|\s+$//g;
		if ($_ && $_ !~ /^</) {
			my $string = $_;
			if ($string =~ /<br>$/) {
#			print "true\n";
				$string =~ s/<br>//;
#			print "$string\n";
			}
	#		$string =~ s/^\s+|\s+$//g;
	#		my $string = unac_string(lc(decode_entities($_).'<br>'));
#			$string = unac_string(lc(decode_entities($_).'<br>'));
#print "$string prior\n";
#print unac_string("UTF-8", $string), " $string prior\n";
#print "$string\n";
			my $basic_string = $string;
			my $ra_string = lc remove_accents($string);
#			utf8::encode($ra_string);
			decode_entities($string);
			my $decoded = $string;
#print "$string\n";			
			$string = unac_string("UTF-8", lc($string).'<br>');
#			$string = remove_accents($string);
#			$string = lc($string).'<br>';
#print "$string\n";
		#	if (exists $list{unac_string(lc(decode_entities($_).'<br>'))}) {
			if (exists($listref->{$string}) || exists($listref->{"$basic_string<br>"}) || exists($listref->{"$ra_string<br>"})  || exists($listref->{"$decoded<br>"})) {	
		#	} else {
		#	} elsif ($string) {
			} else {
#				print "generated $string, $basic_string, $ra_string none found\n";
#				print Dumper $listref;
		#		insert($_, \@list, \%list);
		#		insert($_, \@listordered, \%list);
#				insert($_, \@listordered);
#				insert("$_<br>\n", $listorderedref);
#				insert("$_\n", $listorderedref);
				insert($_, $listorderedref, $listref);								
	#			insert($string, \@listordered);
				$listref->{$string} = undef;	
			}
		}
	}
}
=addreturn
#for (@list) {
for (@listordered) {
	$_.= "\n";
}
=cut

#write_file($outfile, header(), @list, footer());
#write_file($outfile, @list);
#write_file($outfile, header(), @listordered, footer());

sub insert {
#	my ($data, $arrayref, $hashref) = @_;
	my ($data, $arrayref, $listref) = @_;	
#	$hashref->{$data} = undef;
	my $size = scalar @$arrayref;
	my $randompoint = int(rand($size+1)); # could add before first of after last
#	splice @$arrayref, $randompoint, 0, "$data<br>";
#	print "insert $data at point $randompoint\n";
#	splice @$arrayref, $randompoint, 0, encode_entities($data).'<br>'; # $randompoint = 0 => at start = number of elements => at end
	if (exists $listref->{encode_entities_numeric($data, '<>&"')."<br>"}) {
	} else {
		$data .= '<br>' if $data !~ /<br>$/;
		print "insert $data at point $randompoint\n";
		splice @$arrayref, $randompoint, 0, "$data\n"; # $randompoint = 0 => at start = number of elements => at end
	}
#	print "insert $data at point $randompoint\n";
#	print join "\n", @$arrayref;
}

sub header {
	return '<html lang="en">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>Places</title>
  <meta name="Keywords" content="places, data">
  <meta name="Description" content="we are proud to participate in stupidity bring them in transform special html ampersand blah semicolon to coonscript transform that to british english great britain queens UTF-8 for king and country compare to foundlings in a text file basic as they are or do the transform again roll your own remove accents Å => A its considered a separate letter hahaha throw in a utf8::encode($string) compare to quite few different recipes plus copy and paste the brasil stuff changes it to ascii?">
  <meta name="credits" content="www.britannica.com, simplehtmldom.sourceforge.net">
  <link href="../stylesheet.css" rel="stylesheet" type="text/css">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>
';
}

sub footer {
	my $string = read_file('brasil.html');
	return "$string</body>\n</html>";
}

sub remove_accents {
	my $string = shift;
	$string =~ tr/āáǎàēéěèīíǐìïôōóǒòöūúǔùǖǘǚǜüÅĀÁǍÀĒÉĚÈĪÍǏÌŌÓǑÒŪÚǓÙǕǗǙǛÜÇçÑñ/aaaaeeeeiiiiioooooouuuuuuuuuAAAAAEEEEIIIIOOOOUUUUUUUUUCcNn/;
	return $string;
}

sub mixed {
	my $string = shift;
	my @chrs = split '', $string;
	my $s;
	for (@chrs) {
		$s .= chr($_);
	}
	return $s;
}

sub mixedregex { # this is very particlular about where it exists
	s[([0-7]{3})][chr oct $1]egr;
}
